/*-
 * Copyright (C)2012..2014 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2012..2014 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: arr.c,v 1.2 2017/01/09 00:02:10 babolo Exp $";
#endif /* not lint */

#define BLIN_COMPAT  3

#include <sys/types.h>
#include <sysexits.h>
#include <termios.h>
#include <stdlib.h>
#include <stdio.h>
#include <babolo/BLINflag.h>
#include <mercumeter.h>

int
mercumeter_aradd(memeter_arx *arx, u_int32_t data) {
    int ex = EX_OK;

    if  (!arx->arr) {
        if  (!(arx->arr = malloc(MEMETER_ARINIT * sizeof(u_int32_t)))) {
            ifBLIN_QX0("no mem u_int32_t * %u", MEMETER_ARINIT);
            arx->max = 0;
            ex = EX_OSERR;
            goto out;
        }
        arx->idx = 0;
        arx->max = MEMETER_ARINIT;
    }
    if  (  (arx->idx >= arx->max)
        && !(arx->arr = realloc(arx->arr, (arx->max *= 2) * sizeof(u_int32_t)))
        ) {
        ifBLIN_QX0("no mem u_int32_t * %u", arx->max);
        arx->max = 0;
        ex = EX_OSERR;
        goto out;
    }
    arx->arr[arx->idx++] = data;
out:
    return(ex);
}

int
mercumeter_artst(memeter_arx *arx, u_int32_t data) {
    u_int32_t i;
    int ex = 0;

    for (i = 0; i < arx->idx; ++i) {
        if  (arx->arr[i] == data) {
            ex = 1;
            break;
    }   }
    return(ex);
}

int
mercumeter_arnul(memeter_arx *arx) {
    arx->idx = 0;
    return(EX_OK);
}
